#ifndef DZ1SEM3_METHODS_H
#define DZ1SEM3_METHODS_H

#include <fstream>
#include <iostream>
#include <vector>
#include <list>
#include <algorithm>

void CreateDataStream() {
    std::ofstream file("Data.txt");
    for (int i = 0; i < 100; i++)
        file << -50 + rand() % 101 << " ";
}

void CreateDataGenerate() {
    std::ofstream file("Data.txt");
    std::vector<int> data(100);
    std::generate(data.begin(), data.end(), [] {return -50 + std::rand() % 101;});
    std::copy(data.begin(), data.end(), std::ostream_iterator<int>(file, " "));
    file << std::endl;
}

template <typename _Container>
_Container LoadDataStream(std::string_view path) {
    std::ifstream file(path);
    _Container cont;
    using value_type = typename _Container::value_type;
    value_type value;
    while (!file.eof()) {
        file >> value;
        cont.push_back(value);
    }
    return cont;
}

template <typename _Container>
_Container LoadDataIterator(std::string_view path) {
    std::ifstream file(path);
    _Container cont(100);
    using value_type = typename _Container::value_type;
    std::copy(std::istream_iterator<value_type>(file), std::istream_iterator<value_type>(), cont.begin());
    return cont;
}

template <typename _Container>
_Container ModifyTemplate(const _Container& src) {
    _Container result;
    auto min = *std::min_element(src.begin(), src.end());
    auto max = *std::max_element(src.begin(), src.end());
    for (auto& el: src) {
        result.push_back(el / min + max);
    }
    return result;
}

template <typename _SrcIter, typename _DestIter>
void ModifyIter(const _SrcIter src_begin, const _SrcIter src_end, _DestIter dest_begin) {
    auto min = *std::min_element(src_begin, src_end);
    auto max = *std::max_element(src_begin, src_end);
    auto result_begin = dest_begin;
    for (auto it = src_begin; it != src_end; ++it)
        *(result_begin++) = *it / min + max;
}

template <typename _Container>
void ModifyForEach(_Container& src) {
    auto min = *std::min_element(src.begin(), src.end());
    auto max = *std::max_element(src.begin(), src.end());
    auto modify = [min, max](auto& el) {
        el = el / min + max;
        return el;
    };
    std::for_each(src.begin(), src.end(), modify);
}

void ModifyTransform(std::string_view in_fname, std::string_view out_fname) {
    std::ifstream fin(in_fname);
    std::ofstream fout(out_fname);
    std::vector<int> vec(100);
    std::copy(std::istream_iterator<int>(fin), std::istream_iterator<int>(), vec.begin());
    auto min = *std::min_element(vec.begin(), vec.end());
    auto max = *std::max_element(vec.begin(), vec.end());
    auto modify = [min, max](auto& el) {
        el = el / min + max;
        return el;
    };
    std::transform(vec.begin(), vec.end(), std::ostream_iterator<int>(fout, " "), modify);
    fout << std::endl;
}

template <typename _Container>
void OutputResultStream(std::string_view filename, const _Container& src) {
    std::ofstream fout(filename);
    for (const auto& el : src)
        fout << el << " ";
    fout << std::endl;
}

template <typename _Container>
void OutputResultCopy(std::string_view filename, const _Container& src) {
    using value_type = typename _Container::value_type;
    std::ofstream fout(filename, std::ios::app);
    std::copy(src.begin(), src.end(), std::ostream_iterator<value_type>(fout, " "));
    fout << std::endl;
}

#endif //DZ1SEM3_METHODS_H
