#ifndef DZ1SEM3_FILE_H
#define DZ1SEM3_FILE_H

#include "Record.h"
#include "string"
#include "map"

class File {
private:
    friend Record;
    std::string fname;
    std::map<int, Record> rec_arr;
public:
    explicit File(std::string_view);
    void CreateFile();
    void GetData();
    void AddToFile(const std::initializer_list<Record> &lst);
    void DelFromFile(int);
    void Replace(int ind, const Record &rec);
    void ToText();
    void SearchByHouseN(int);
    void SearchByFlatN(int);
    void SearchBySecondName(const std::string &r_secondName);
    void SearchByOperType(const std::string &r_operType);
    void SearchByDate(const std::string &r_date);
};


#endif //DZ1SEM3_FILE_H
