#include "Record.h"
#include "iostream"

Record::Record(int r_houseN, int r_flatN, std::string_view r_secondName, std::string_view r_operType,
               std::string_view r_date, int r_operSum, int r_penalties, int r_delay) :
   houseN(r_houseN),
   flatN(r_flatN),
   secondName(r_secondName),
   operType(r_operType),
   date(r_date),
   operSum(r_operSum),
   penalties(r_penalties),
   delay(r_delay) {}

Record &Record::operator=(const Record &rec) {
    if (this == &rec)
        return *this;
    houseN = rec.houseN;
    flatN = rec.flatN;
    secondName = rec.secondName;
    operType = rec.operType;
    date = rec.date;
    operSum = rec.operSum;
    penalties = rec.penalties;
    delay = rec.delay;
    return *this;
}


std::istream &operator>>(std::istream &in, Record &rec) {
    in >> rec.houseN
       >> rec.flatN
       >> rec.secondName
       >> rec.operType
       >> rec.date
       >> rec.operSum
       >> rec.penalties
       >> rec.delay;
    return in;
}

std::ostream &operator<<(std::ostream &out, const Record &rec) {
    out << rec.houseN << std::endl
        << rec.flatN << std::endl
        << rec.secondName << std::endl
        << rec.operType << std::endl
        << rec.date << std::endl
        << rec.operSum << std::endl
        << rec.penalties << std::endl
        << rec.delay << std::endl;
    return out;
}

